package vin;

import java.awt.Graphics;
import java.awt.Toolkit;
import java.awt.Image;
import java.awt.image.*;
import java.awt.image.BufferedImage;
import javax.imageio.ImageIO;
import javax.imageio.ImageWriteParam;
import javax.imageio.ImageWriter;
import javax.imageio.IIOImage;
import javax.imageio.stream.ImageOutputStream;
import java.io.*;
import java.util.Iterator;

import java.awt.*;
import java.awt.event.*;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JToolBar;
import javax.swing.JButton;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JTextArea;
import javax.swing.JScrollPane;
import javax.swing.*;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import java.awt.Dimension;
import java.util.Vector;


public class MainFrame extends JFrame {
    JPanel contentPane;
    BorderLayout borderLayout1 = new BorderLayout();
    GridLayout gridLayout1 = new GridLayout(8,3);
    GridLayout gridLayout2 = new GridLayout(3,1);
    JMenuBar jMenuBar1 = new JMenuBar();
    JMenu jMenuFile = new JMenu();
    JMenuItem jMenuFileChart = new JMenuItem();
    JMenuItem jMenuFileSave = new JMenuItem();
    JMenuItem jMenuFileExit = new JMenuItem();
    JMenu jMenuHelp = new JMenu();
    JToolBar jToolBar = new JToolBar();
    JPanel buttonsPanel = new JPanel();
    JPanel slidersPanel = new JPanel();
    JSlider jSlider1 = new JSlider();
    JButton jButton2 = new JButton();
    JButton jButton3 = new JButton();
    JButton jButton5 = new JButton();
    JLabel label1 = new JLabel("     poet etzc");
    JLabel label4 = new JLabel("     Text pro kol");
    JLabel label8 = new JLabel();
    JLabel label9 = new JLabel();
    JLabel label10 = new JLabel();
    JLabel label12 = new JLabel("     font");
    JLabel label13 = new JLabel("     styl");    
    JLabel label15 = new JLabel();    
    JLabel label18 = new JLabel("     output format");    
    JLabel label19 = new JLabel();     
    
    JTextField jTextField1 = new javax.swing.JTextField();
    
    JColorChooser jColorChooser1 = new javax.swing.JColorChooser();
    
    JFileChooser jFileChooser1 = new javax.swing.JFileChooser();
    
    

/******************************************************************************/        
    JComboBox  fontCombo;  // for selecting one of the installed fonts.
    JComboBox  styleCombo; // for selecting style (plain, bold, ...)
    JComboBox  qualityCombo; // for selecting of quality
    JComboBox  formatCombo; // for selecting of quality

    int currentStyle = Font.BOLD;
    String currentStyleString = "bold";
    String initialFontName    = "Arial Black";
    String currentFont = "Arial Black";
    String currentQualityString = "high quality";
    String currentFormatString = "png";

    static final String[] fontStyleString = new String[] 
        {"plain", "italic", "bold", "italic+bold"};
    static final    int[] fontStyleInt    = new    int[] 
        { Font.PLAIN ,  Font.ITALIC ,  Font.BOLD ,  Font.ITALIC+Font.BOLD };
    static final String[] qualityString = new String[] 
        {"high quality", "high speed"};
    static final String[] formatString = new String[] 
        {"png", "jpg"};        
/******************************************************************************/        
        
    
    
    
    DrawFrame drawFrame1 = new DrawFrame(this);

    private boolean started = false;
    private static float NUMOBJS_DIVIDER = 1.0f;
   
    public MainFrame() {
        try {
            setDefaultCloseOperation(EXIT_ON_CLOSE);
            jbInit();
        } catch (Exception exception) {
            exception.printStackTrace();
        }
    }

    // inicializace aplikace
    private void jbInit() throws Exception {
        contentPane = (JPanel) getContentPane();
        contentPane.setLayout(borderLayout1);
        setSize(new Dimension(460, 300));
        //this.setResizable(false);
        setTitle("Generator textu pro kol");

        jMenuFile.setText("Soubor");

        jMenuFileChart.setText("Uka vykreslovac okno");
        jMenuFileChart.addActionListener(new
                                        MainFrame_jMenuFileChart_ActionAdapter(this));
        jMenuFileExit.setText("Exit");
        jMenuFileExit.addActionListener(new
                                        MainFrame_jMenuFileExit_ActionAdapter(this));
        jMenuFileSave.setText("Uloit");
        jMenuFileSave.addActionListener(new
                                        MainFrame_jMenuFileSave_ActionAdapter(this));
        jMenuBar1.add(jMenuFile);
        jMenuFile.add(jMenuFileChart);
        jMenuFile.add(jMenuFileSave);
        jMenuFile.add(jMenuFileExit);
        
        setJMenuBar(jMenuBar1);

        jToolBar.setFloatable(false);

        jButton3.setText("Generuj");
        jButton3.addActionListener(new MainFrame_jButton3_actionAdapter(this));
        jButton2.setText("Barva pozad");
        jButton2.addActionListener(new MainFrame_jButton2_actionAdapter(this));
        jButton5.setText("Barva textu");
        jButton5.addActionListener(new MainFrame_jButton5_actionAdapter(this));
        jSlider1.addPropertyChangeListener(new
                MainFrame_jSlider1_propertyChangeAdapter(this));
        jSlider1.addChangeListener(new MainFrame_jSlider1_changeAdapter(this));
        jSlider1.setMinimum(1);
        jSlider1.setMaximum(1000);
        jSlider1.setValue(200);
        
        jTextField1.setText("komunikace");
        
        
/******************************************************************************/
        // --- Get all font families
        String[] fontNames = GraphicsEnvironment
                             .getLocalGraphicsEnvironment()
                             .getAvailableFontFamilyNames();

        // --- Make vector of all fonts that can display basic chars
        Vector visFonts = new Vector(fontNames.length);
        for (int i=0; i<fontNames.length; i++) {
            Font f = new Font(fontNames[i], Font.PLAIN, 12);
            if (f.canDisplay('a')) {
                // Display only fonts that have the alphabetic characters.
                // On my machine there are almost 20 fonts (eg, Wingdings)
                // that don't display text.
                visFonts.add(fontNames[i]);
            } else {
                //System.out.println("No alphabetics in " + fontNames[i]);
            }
        }

        fontCombo = new JComboBox(visFonts);         // JComboBox of fonts
        fontCombo.setSelectedItem(initialFontName);  // select the default font
        fontCombo.addActionListener(new MainFrame_jComboFont_ActionAdapter(this));

        // --- Style: create a Choice drop-down menu ---------------
        styleCombo = new JComboBox(fontStyleString);
        styleCombo.setSelectedItem(currentStyleString);
        styleCombo.addActionListener(new MainFrame_jComboStyle_ActionAdapter(this));

        qualityCombo = new JComboBox(qualityString);
        qualityCombo.setSelectedItem(currentQualityString);
        qualityCombo.addActionListener(new MainFrame_jComboQuality_ActionAdapter(this));
        
        formatCombo = new JComboBox(formatString);
        formatCombo.setSelectedItem(currentFormatString);
        formatCombo.addActionListener(new MainFrame_jComboFormat_ActionAdapter(this));


/******************************************************************************/             
             
                     
        


        jToolBar.add(buttonsPanel);
        buttonsPanel.setLayout(gridLayout2);
        buttonsPanel.add(jButton3);
        buttonsPanel.add(jButton2);
        buttonsPanel.add(jButton5);
        

        jToolBar.add(slidersPanel);
        slidersPanel.setLayout(gridLayout1);
        
        slidersPanel.add(label4);
        slidersPanel.add(jTextField1);
       

        slidersPanel.add(label12);
        slidersPanel.add(fontCombo);
        

        slidersPanel.add(label13);
        slidersPanel.add(styleCombo);        
       

        slidersPanel.add(label18);
        slidersPanel.add(formatCombo);        
            
                
        slidersPanel.add(label1);    
        slidersPanel.add(jSlider1);
        slidersPanel.add(label15);
        slidersPanel.add(label8);

               contentPane.add(jToolBar, java.awt.BorderLayout.NORTH);
                
                             
        this.drawFrame1.show();
    }

  
    // metoda pro osetreni udalosti ovladaciho prvku - ulozeni obrazku
    void jMenuFileExit_actionPerformed(ActionEvent actionEvent) {
        System.exit(0);
    }
    void jMenuFileSave_actionPerformed(ActionEvent actionEvent) {
         ExampleFileFilter filter = new ExampleFileFilter();
         
      if (this.drawFrame1.format == 0) {
        filter.addExtension("png");
        filter.setDescription("PNG Images");
      } else {
        filter.addExtension("jpg");
        filter.setDescription("JPG Images");        
      }
      this.jFileChooser1.setFileFilter(filter);
      this.jFileChooser1.setCurrentDirectory(new File("./"));
      this.jFileChooser1.showSaveDialog(this);

      if (this.jFileChooser1.getSelectedFile() != null) {      
       
        // vytvoreni buffered image do ktereho se bude kreslit
        drawFrame1.bufferedImage = new BufferedImage(drawFrame1.getWidth(), drawFrame1.getHeight(), BufferedImage.TYPE_INT_RGB); 
        // vytvoreni grafickeho kontextu obrazku
        drawFrame1.ig2d = drawFrame1.bufferedImage.createGraphics();        
        drawFrame1.ig2d.setBackground(drawFrame1.bgcol);
        drawFrame1.ig2d.setColor(drawFrame1.col);
        drawFrame1.ig2d.clearRect(0,0, drawFrame1.getWidth(), drawFrame1.getHeight());
         
        drawFrame1.myPaint(drawFrame1.g, true, false);
               
        // ulozeni obrazku do souboru
        try {
         
            RenderedImage rendImage = drawFrame1.bufferedImage;       
          
            File file = new File(this.jFileChooser1.getSelectedFile().getAbsolutePath());
            if (drawFrame1.format == 0) {
              // ulozit jako PNG
              ImageIO.write(rendImage, "png", file);
              
            } else {
              // ulozit jako JPG
              
              String formatString = "jpg";
            
              ImageOutputStream ios = ImageIO.createImageOutputStream(file);
      
              ImageWriter writer = null;
              Iterator iter = ImageIO.getImageWritersByFormatName(formatString);
              if (iter.hasNext()) {
                  writer = (ImageWriter)iter.next();
              }
  
              writer.setOutput(ios);
              ImageWriteParam iwparam = writer.getDefaultWriteParam();
              iwparam.setCompressionMode(ImageWriteParam.MODE_EXPLICIT);
              iwparam.setCompressionQuality(1.0f) ;
              writer.write(null, new IIOImage(rendImage, null, null), iwparam);
              ios.flush();
              writer.dispose();
              ios.close();
            }

        } catch (IOException ex) {
        }                 

        drawFrame1.ig2d.dispose();
      }
    }
    
    // metoda pro osetreni udalosti ovladaciho prvku - zobrazeni vykreslovaciho okna
    void jMenuFileChart_actionPerformed(ActionEvent actionEvent) {
        this.drawFrame1.show();
    }

   
    // metoda pro osetreni udalosti ovladaciho prvku - reset
    public void jButton3_actionPerformed(ActionEvent e) {
        this.drawFrame1.initObjs(this.drawFrame1.numobjs);
        this.drawFrame1.repaint();
    }    

    // metoda pro osetreni udalosti ovladaciho prvku - nastaveni barvy 
    public void jButton5_actionPerformed(ActionEvent e) {
        this.drawFrame1.col = jColorChooser1.showDialog(this, "choose color", this.drawFrame1.col); 
        this.drawFrame1.repaint();
    }
    
    // metoda pro osetreni udalosti ovladaciho prvku - nastaveni barvy pozadni
    public void jButton2_actionPerformed(ActionEvent e) {
        this.drawFrame1.bgcol = jColorChooser1.showDialog(this, "choose color", this.drawFrame1.bgcol);     
        this.drawFrame1.repaint();
    }    


    // metoda pro osetreni udalosti ovladaciho prvku - pocet objektu
    public void jSlider1_propertyChange(PropertyChangeEvent evt) {
        this.label8.setText(""+(float)this.jSlider1.getValue()/NUMOBJS_DIVIDER);
        this.drawFrame1.initObjs((int)(this.jSlider1.getValue()/NUMOBJS_DIVIDER));
    }
    public void jSlider1_stateChanged(ChangeEvent e) {
        this.label8.setText(""+(float)this.jSlider1.getValue()/NUMOBJS_DIVIDER);
        this.drawFrame1.initObjs((int)(this.jSlider1.getValue()/NUMOBJS_DIVIDER));
    }

    
    // metoda pro osetreni udalosti ovladaciho prvku - styl pisma
    public void jComboStyle_actionPerformed(ActionEvent e) {     
        this.drawFrame1.currentStyle = fontStyleInt[styleCombo.getSelectedIndex()];
        this.drawFrame1.currentStyleString = (String)styleCombo.getSelectedItem();      
    }  
    
    // metoda pro osetreni udalosti ovladaciho prvku - font pisma
    public void jComboFont_actionPerformed(ActionEvent e) {
        this.drawFrame1.currentFont = (String)fontCombo.getSelectedItem();      
    }
  
    // metoda pro osetreni udalosti ovladaciho prvku - kvalita
    public void jComboQuality_actionPerformed(ActionEvent e) {
        this.drawFrame1.quality = (((String)qualityCombo.getSelectedItem()).compareTo("high quality")==0) ? 0 : 1;      
    }  
    
    // metoda pro osetreni udalosti ovladaciho prvku - format vystupu
    public void jComboFormat_actionPerformed(ActionEvent e) {
        this.drawFrame1.format = (((String)qualityCombo.getSelectedItem()).compareTo("png")==0) ? 0 : 1;      
    }      


}


// tridy pro obsluhu udalosti

class MainFrame_jButton3_actionAdapter implements ActionListener {
    private MainFrame adaptee;
    MainFrame_jButton3_actionAdapter(MainFrame adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButton3_actionPerformed(e);
    }
}


class MainFrame_jSlider1_propertyChangeAdapter implements
        PropertyChangeListener {
    private MainFrame adaptee;
    MainFrame_jSlider1_propertyChangeAdapter(MainFrame adaptee) {
        this.adaptee = adaptee;
    }

    public void propertyChange(PropertyChangeEvent evt) {
        adaptee.jSlider1_propertyChange(evt);
    }
}


class MainFrame_jSlider1_changeAdapter implements ChangeListener {
    private MainFrame adaptee;
    MainFrame_jSlider1_changeAdapter(MainFrame adaptee) {
        this.adaptee = adaptee;
    }

    public void stateChanged(ChangeEvent e) {
        adaptee.jSlider1_stateChanged(e);
    }
}


class MainFrame_jButton2_actionAdapter implements ActionListener {
    private MainFrame adaptee;
    MainFrame_jButton2_actionAdapter(MainFrame adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButton2_actionPerformed(e);
    }
}


class MainFrame_jButton5_actionAdapter implements ActionListener {
    private MainFrame adaptee;
    MainFrame_jButton5_actionAdapter(MainFrame adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButton5_actionPerformed(e);
    }
}


class MainFrame_jMenuFileExit_ActionAdapter implements ActionListener {
    MainFrame adaptee;

    MainFrame_jMenuFileExit_ActionAdapter(MainFrame adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent actionEvent) {
        adaptee.jMenuFileExit_actionPerformed(actionEvent);
    }
}
class MainFrame_jMenuFileSave_ActionAdapter implements ActionListener {
    MainFrame adaptee;

    MainFrame_jMenuFileSave_ActionAdapter(MainFrame adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent actionEvent) {
        adaptee.jMenuFileSave_actionPerformed(actionEvent);
    }
}

class MainFrame_jMenuFileChart_ActionAdapter implements ActionListener {
    MainFrame adaptee;

    MainFrame_jMenuFileChart_ActionAdapter(MainFrame adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent actionEvent) {
        adaptee.jMenuFileChart_actionPerformed(actionEvent);
    }
}

class  MainFrame_jComboFont_ActionAdapter implements ActionListener {
    MainFrame adaptee;

    MainFrame_jComboFont_ActionAdapter(MainFrame adaptee) {
        this.adaptee = adaptee;
    }  
    
    public void actionPerformed(ActionEvent actionEvent) {
        adaptee.jComboFont_actionPerformed(actionEvent);
    }
}


class  MainFrame_jComboStyle_ActionAdapter implements ActionListener {
    MainFrame adaptee;

    MainFrame_jComboStyle_ActionAdapter(MainFrame adaptee) {
        this.adaptee = adaptee;
    }  
    
    public void actionPerformed(ActionEvent actionEvent) {
        adaptee.jComboStyle_actionPerformed(actionEvent);
    }
}

class  MainFrame_jComboQuality_ActionAdapter implements ActionListener {
    MainFrame adaptee;

    MainFrame_jComboQuality_ActionAdapter(MainFrame adaptee) {
        this.adaptee = adaptee;
    }  
    
    public void actionPerformed(ActionEvent actionEvent) {
        adaptee.jComboQuality_actionPerformed(actionEvent);
    }
}


class  MainFrame_jComboFormat_ActionAdapter implements ActionListener {
    MainFrame adaptee;

    MainFrame_jComboFormat_ActionAdapter(MainFrame adaptee) {
        this.adaptee = adaptee;
    }  
    
    public void actionPerformed(ActionEvent actionEvent) {
        adaptee.jComboFormat_actionPerformed(actionEvent);
    }
}
