{#############################################################################}
{#                                                                           #}
{#  WinQUANT v2 - source code                                                #}
{#  Delphi version                                                           #}
{#  File: About.pas v2.0                                                     #}
{#                                                                           #}
{#  (C) 2001 Petr Strnsk                                                   #}
{#  All rights reserved                                                      #}
{#                                                                           #}
{#  Web:     http://www.fi.muni.cz/~xstransk/winquant                        #}
{#  E-mail:  xstransk@fi.muni.cz                                             #}
{#           aargh@email.cz                                                  #}
{#                                                                           #}
{#############################################################################}
{#                                                                           #}
{#  This file is distributed as freeware and without warranties of any kind. #}
{#  You can use it in your own applications at your own risk.                #}
{#  See help file for more information.                                      #}
{#                                                                           #}
{#############################################################################}

unit About;

interface

uses Windows, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, jpeg;

type
  TAboutBox = class(TForm)
    Panel1: TPanel;
    OKButton: TButton;
    ProgramIcon: TImage;
    ProductName: TLabel;
    Version: TLabel;
    Copyright: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure ProgramIconClick(Sender: TObject);
    procedure ProductNameClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  AboutBox: TAboutBox;

implementation

{$R *.DFM}

uses Dialogs;

{** Secret area I **}
var MysteriousSecretVariable: byte;
    SecretFound: boolean;
{** End of secret area I **}

procedure TAboutBox.FormCreate(Sender: TObject);
begin
  {** Secret area II **}
  MysteriousSecretVariable := 0;
  SecretFound := false;
  {** End of secret area II **}
end;

procedure TAboutBox.ProgramIconClick(Sender: TObject);
begin
  {** Secret area III **}
  if SecretFound then begin
    ShowMessage('You have already found the secret window. There are no other secret windows. Stop this useless clicking and get back to work. Now!! :-)');
    Exit;
 end;
  if MysteriousSecretVariable > 9 then begin
    ShowMessage('CONGRATULATIONS!! You have found the Secret Window. You are so clever! The God of All Computers is pleased. :-) Well ... that''s all. Have a nice day.');
    SecretFound := true;
    Exit;
  end;
  if MysteriousSecretVariable mod 2 = 0 then Inc(MysteriousSecretVariable)
  else MysteriousSecretVariable := 0;
  {** End of secret area III **}
end;

procedure TAboutBox.ProductNameClick(Sender: TObject);
begin
  {** Secret area IV **}
  if not SecretFound then
    if MysteriousSecretVariable mod 2 = 1 then Inc(MysteriousSecretVariable)
    else MysteriousSecretVariable := 0;
  {** End of secret area IV **}
end;

end.

