{#############################################################################}
{#                                                                           #}
{#  WinQUANT v2 - source code                                                #}
{#  Delphi version                                                           #}
{#  File: Preferences.pas v2.0                                               #}
{#                                                                           #}
{#  (C) 2001 Petr Strnsk                                                   #}
{#  All rights reserved                                                      #}
{#                                                                           #}
{#  Web:     http://www.fi.muni.cz/~xstransk/winquant                        #}
{#  E-mail:  xstransk@fi.muni.cz                                             #}
{#           aargh@email.cz                                                  #}
{#                                                                           #}
{#############################################################################}
{#                                                                           #}
{#  This file is distributed as freeware and without warranties of any kind. #}
{#  You can use it in your own applications at your own risk.                #}
{#  See help file for more information.                                      #}
{#                                                                           #}
{#############################################################################}

unit Preferences;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, Spin, ComCtrls;

type
  TPreferencesDlg = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    GroupBox1: TGroupBox;
    QualityTrack: TTrackBar;
    Label1: TLabel;
    QualityLabel: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure QualityTrackChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PreferencesDlg: TPreferencesDlg;

implementation

{$R *.DFM}

procedure TPreferencesDlg.QualityTrackChange(Sender: TObject);
begin
  QualityLabel.Caption := IntToStr(QualityTrack.Position) + '%';
end;

end.
