{#############################################################################}
{#                                                                           #}
{#  WinQUANT v2 - source code                                                #}
{#  Delphi version                                                           #}
{#  File: WinQUANT.dpr v2.0                                                  #}
{#                                                                           #}
{#  (C) 2001 Petr Strnsk                                                   #}
{#  All rights reserved                                                      #}
{#                                                                           #}
{#  Web:     http://www.fi.muni.cz/~xstransk/winquant                        #}
{#  E-mail:  xstransk@fi.muni.cz                                             #}
{#           aargh@email.cz                                                  #}
{#                                                                           #}
{#############################################################################}
{#                                                                           #}
{#  This file is distributed as freeware and without warranties of any kind. #}
{#  You can use it in your own applications at your own risk.                #}
{#  See help file for more information.                                      #}
{#                                                                           #}
{#############################################################################}

program WinQuant;

{%ToDo 'WinQuant.todo'}

uses
  Forms,
  Result in 'Result.pas' {ResultWin},
  About in 'About.pas' {AboutBox},
  MainWin in 'MainWin.pas' {PagesDlg},
  Bookmark in 'Bookmark.pas',
  Calculations in 'Calculations.pas',
  UParserStack in 'UParserStack.pas',
  UParser in 'UParser.pas',
  Preferences in 'Preferences.pas' {PreferencesDlg},
  BookmarkManager in 'BookmarkManager.pas' {BookmarkManagerDlg};

{$R *.RES}

begin
  Application.Initialize;
  Application.Title := 'WinQUANT';
  Application.HelpFile := 'C:\Prog\Delphi\WinQuant\WINQUANT.hlp';
  Application.CreateForm(TPagesDlg, PagesDlg);
  Application.CreateForm(TResultWin, ResultWin);
  Application.CreateForm(TAboutBox, AboutBox);
  Application.CreateForm(TPreferencesDlg, PreferencesDlg);
  Application.CreateForm(TBookmarkManagerDlg, BookmarkManagerDlg);
  Application.Run;
end.

